import React, { CSSProperties } from "react";
import { CommonProps, TypeAttributes } from "../@types/common";
export interface DropdownProps<T = string> extends CommonProps {
    /** Palcement of the dropdown menu */
    placement?: TypeAttributes.Placement8;
    /** Dropdown open */
    open?: boolean;
    /** Toggle component */
    toggle?: React.ReactNode;
    /** Use for custom toggle component */
    renderToggle?: (children: React.ReactNode) => React.ReactNode;
    /** Callback function when menu is show  */
    onOpen?: () => void;
    /** Callback function on menu is closed */
    onClose?: () => void;
    /** Callback function for menu state switching */
    onToggle?: (open?: boolean) => void;
    /** Selected item callback */
    onSelect?: (itemKey: T, event: React.MouseEvent<HTMLElement>) => void;
    /** The selected item key */
    activeKey?: T;
    /** Use for style the dropdown menu */
    menuStyle?: CSSProperties;
}
declare const Dropdown: React.FC<DropdownProps>;
export default Dropdown;
