var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useRef, useState, } from "react";
import _ from "lodash";
import { overlayClose, useClassNames } from "../utils";
import DropdownMenu from "./DropdownMenu";
import DropdownToggle from "./DropdownToggle";
import createChainedFunction from "../utils/createChainedFunction";
var Dropdown = function (props) {
    var _a = props.componentClass, Component = _a === void 0 ? "div" : _a, _b = props.classPrefix, classPrefix = _b === void 0 ? "dropdown" : _b, children = props.children, className = props.className, placement = props.placement, toggle = props.toggle, renderToggle = props.renderToggle, onToggle = props.onToggle, onClose = props.onClose, onOpen = props.onOpen, onClick = props.onClick, openProp = props.open, onSelect = props.onSelect, activeKey = props.activeKey, menuStyle = props.menuStyle;
    var _c = useClassNames(classPrefix), merge = _c.merge, withClassPrefix = _c.withClassPrefix;
    var classes = merge(className, withClassPrefix());
    var _d = useState(openProp || false), open = _d[0], setOpen = _d[1];
    var rootRef = React.createRef();
    var triggerTarget = useRef();
    var overlayTarget = useRef();
    var getOpen = function () {
        if (_.isUndefined(openProp)) {
            return open;
        }
        return openProp;
    };
    var handleToggle = useCallback(function (isOpen) {
        var nextOpen = _.isUndefined(isOpen) ? !getOpen() : isOpen;
        var fn = nextOpen ? onOpen : onClose;
        fn === null || fn === void 0 ? void 0 : fn();
        setOpen(nextOpen);
        onToggle === null || onToggle === void 0 ? void 0 : onToggle(nextOpen);
    }, [open, setOpen, onOpen, onClose]);
    var handleClick = useCallback(function (event) {
        event.preventDefault();
        handleToggle();
    }, [handleToggle]);
    var handleSelect = useCallback(function (itemKey, event) {
        onSelect === null || onSelect === void 0 ? void 0 : onSelect(itemKey, event);
        handleToggle(false);
    }, []);
    overlayClose(function () { return handleToggle(); }, {
        triggerTarget: triggerTarget,
        overlayTarget: overlayTarget,
        disabled: !open
    });
    var dropdownToggleProps = {
        onClick: createChainedFunction(handleClick, onClick)
    };
    var dropdownToggleElement = (React.createElement(DropdownToggle, __assign({ ref: triggerTarget, renderToggle: renderToggle }, dropdownToggleProps), toggle));
    var dropdownMenuProps = {
        open: open,
        placement: placement
    };
    var dropdownMenuElement = (React.createElement(DropdownMenu, __assign({ ref: overlayTarget, style: menuStyle, activeKey: activeKey, onSelect: handleSelect }, dropdownMenuProps), children));
    return (React.createElement(Component, { ref: rootRef, className: classes },
        dropdownToggleElement,
        dropdownMenuElement));
};
Dropdown.defaultProps = {
    placement: "bottomStart"
};
export default Dropdown;
