import React, { SyntheticEvent } from "react";
import { CommonProps } from "../@types/common";
export interface DropdownItemProps<T = string> extends CommonProps {
    /** Active options */
    active?: boolean;
    /** The specified url path */
    href?: string;
    /** On select item callback */
    onSelect?: (itemKey?: T, event?: SyntheticEvent) => void;
    /** The unique key of the item option */
    itemKey?: T;
}
declare const DropdownItem: React.ForwardRefExoticComponent<Pick<DropdownItemProps<string>, string | number> & React.RefAttributes<unknown>>;
export default DropdownItem;
