var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useContext } from "react";
import { useClassNames } from "../utils";
import MainHeader from "./MainHeader";
import HeaderIcon from "./HeaderIcon";
import HeaderExtra from "./HeaderExtra";
import { PageContext } from "../Page";
import SidebarExpanderIcon from "./SidebarExpanderIcon";
var Header = function (props) {
    var _a = props.componentClass, Component = _a === void 0 ? "div" : _a, _b = props.classPrefix, classPrefix = _b === void 0 ? "page-header" : _b, className = props.className, title = props.title, renderTitle = props.renderTitle, navigation = props.navigation, headerIcon = props.headerIcon, extraElement = props.extraElement;
    var setMinimizedSidebar = useContext(PageContext).setMinimizedSidebar;
    var _c = useClassNames(classPrefix), merge = _c.merge, withClassPrefix = _c.withClassPrefix, prefix = _c.prefix;
    var classes = merge(className, withClassPrefix({}));
    var handleCollapseSidebar = function () {
        setMinimizedSidebar === null || setMinimizedSidebar === void 0 ? void 0 : setMinimizedSidebar(false);
    };
    var mainHeaderProps = {
        title: title,
        navigation: navigation,
        renderTitle: renderTitle
    };
    var headerIconElement;
    if (headerIcon) {
        headerIconElement = React.createElement(HeaderIcon, null, headerIcon);
    }
    var headerExtraElement;
    if (extraElement) {
        headerExtraElement = React.createElement(HeaderExtra, null, extraElement);
    }
    return (React.createElement(Component, { className: classes },
        React.createElement("div", { className: prefix("sidebar-expander"), onClick: function () { return handleCollapseSidebar(); } },
            React.createElement(SidebarExpanderIcon, { height: "20", width: "20" })),
        headerIconElement,
        React.createElement(MainHeader, __assign({}, mainHeaderProps)),
        headerExtraElement));
};
Header.defaultProps = {
    componentClass: "div",
    classPrefix: "page-header"
};
export default Header;
