var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useContext, useEffect } from "react";
import { PageContext } from "../Page";
import { useClassNames } from "../utils";
var Sidebar = function (props) {
    var _a = props.componentClass, Component = _a === void 0 ? "aside" : _a, children = props.children, _b = props.classPrefix, classPrefix = _b === void 0 ? "sidebar" : _b, _c = props.width, width = _c === void 0 ? 240 : _c, className = props.className, collapsible = props.collapsible, expander = props.expander, style = props.style, rest = __rest(props, ["componentClass", "children", "classPrefix", "width", "className", "collapsible", "expander", "style"]);
    var _d = useContext(PageContext), setHasSidebar = _d.setHasSidebar, setMinimizedSidebar = _d.setMinimizedSidebar;
    var _e = useClassNames(classPrefix), withClassPrefix = _e.withClassPrefix, merge = _e.merge;
    var classes = merge(className, withClassPrefix({ collapse: collapsible }));
    // hook to the Page component that the child has a sidebar.
    useEffect(function () {
        setHasSidebar === null || setHasSidebar === void 0 ? void 0 : setHasSidebar(true);
    }, [setHasSidebar]);
    var handleCollapse = function () {
        setMinimizedSidebar === null || setMinimizedSidebar === void 0 ? void 0 : setMinimizedSidebar(true);
        // setIsCollapsible(!isCollapsible);
    };
    var styles = __assign({ width: width + "px" }, style);
    var getElements = function () {
        var elements = React.Children.map(children, function (child, index) {
            var _a;
            var displayName = (_a = child === null || child === void 0 ? void 0 : child.type) === null || _a === void 0 ? void 0 : _a.displayName;
            if (displayName === "SidebarHeader") {
                return React.cloneElement(child, __assign({ key: index, expander: expander, handleCollapse: function () { return handleCollapse; } }, child === null || child === void 0 ? void 0 : child.props));
            }
            return React.cloneElement(child, __assign({ key: index }, child === null || child === void 0 ? void 0 : child.props));
        });
        return { elements: elements };
    };
    var elements = getElements().elements;
    return (React.createElement(Component, __assign({ style: styles, className: classes }, rest), elements));
};
Sidebar.defaultProps = {
    width: 240,
    classPrefix: "sidebar",
    componentClass: "aside"
};
export default Sidebar;
