import * as helpers from 'dom-lib';
export * from 'dom-lib';
declare const DOMHelper: {
    animation: typeof helpers.animation;
    transition: () => {
        end: any;
        backfaceVisibility: string;
        transform: string;
        property: string;
        timing: string;
        delay: string;
        duration: string;
    };
    translateDOMPositionXY: (style: CSSStyleDeclaration, x?: number | undefined, y?: number | undefined) => CSSStyleDeclaration;
    getVendorPrefixedName: typeof helpers.getVendorPrefixedName;
    BrowserSupportCore: {
        hasCSSAnimations: () => boolean;
        hasCSSTransforms: () => boolean;
        hasCSS3DTransforms: () => boolean;
        hasCSSTransitions: () => boolean;
    };
    DOMMouseMoveTracker: typeof helpers.DOMMouseMoveTracker;
    WheelHandler: typeof helpers.WheelHandler;
    addClass: (target: Element, className: string) => Element;
    hasClass: (target: Element, className: string) => boolean;
    removeClass: (target: Element, className: string) => Element;
    toggleClass: (target: Element, className: string) => Element;
    getStyle: (node: Element, property?: string | undefined) => string | CSSStyleDeclaration;
    removeStyle: (node: Element, keys: string | string[]) => void;
    addStyle: (node: Element, property: string | import("dom-lib/lib/style/addStyle").CSSProperty, value?: string | number | undefined) => void;
    getComputedStyle: (node: Element) => CSSStyleDeclaration | null;
    ownerDocument: (node: Element) => Document;
    ownerWindow: (componentOrElement: Element) => Window;
    getWindow: (node: any) => Window;
    getContainer: (container: Element | (() => Element), defaultContainer?: Element | undefined) => Element;
    canUseDOM: boolean;
    contains: (context: Element, node: Node & ParentNode) => boolean;
    scrollTop: (node: Element, val?: number | undefined) => number;
    scrollLeft: (node: Element, val?: number | undefined) => number;
    getOffset: (node: Element) => DOMRect | {
        top: number;
        left: number;
        height: number;
        width: number;
    } | null;
    nodeName: (node: Element) => string;
    getOffsetParent: (node: Element) => Element;
    getPosition: (node: Element, offsetParent?: Element | undefined) => DOMRect | {
        top: number;
        left: number;
        height: number;
        width: number;
    } | null;
    isOverflowing: (container: Element) => boolean;
    activeElement: (doc?: Document | undefined) => Element;
    getScrollbarSize: (recalc?: boolean | undefined) => number | void;
    getHeight: (node: Element | Window, client?: Element | undefined) => number;
    getWidth: (node: Element | Window, client?: Element | undefined) => number;
    on: typeof helpers.on;
    off: typeof helpers.off;
};
export default DOMHelper;
