var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { kebabCase } from "lodash";
import * as React from "react";
import { useClassNames } from ".";
var createComponent = function (defaultProps) {
    var as = defaultProps.as, name = defaultProps.name, classPrefix = defaultProps.classPrefix, componentRestProps = __rest(defaultProps, ["as", "name", "classPrefix"]);
    var Component = React.forwardRef(function (props, ref) {
        var Component = props.as, children = props.children, className = props.className, classPrefix = props.classPrefix, rest = __rest(props, ["as", "children", "className", "classPrefix"]);
        var _a = useClassNames(classPrefix), merge = _a.merge, withClassPrefix = _a.withClassPrefix;
        var classes = merge(className, withClassPrefix());
        return (React.createElement(Component, __assign({ ref: ref, className: classes }, rest), children));
    });
    Component.displayName = name;
    Component.defaultProps = __assign(__assign({}, componentRestProps), { as: as || "div", classPrefix: classPrefix || kebabCase(name) });
    return Component;
};
export default createComponent;
