"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _taggedTemplateLiteralLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteralLoose"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _Anchor = _interopRequireDefault(require("../Anchor/Anchor"));

var _utils = require("../utils");

var _templateObject;

var Button = function Button(props) {
  var active = props.active,
      _props$appearance = props.appearance,
      appearance = _props$appearance === void 0 ? "default" : _props$appearance,
      _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "button" : _props$componentClass,
      children = props.children,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "btn" : _props$classPrefix,
      color = props.color,
      className = props.className,
      disabled = props.disabled,
      href = props.href,
      loading = props.loading,
      block = props.block,
      size = props.size,
      type = props.type,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["active", "appearance", "componentClass", "children", "classPrefix", "color", "className", "disabled", "href", "loading", "block", "size", "type"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      withClassPrefix = _useClassNames.withClassPrefix,
      prefix = _useClassNames.prefix,
      merge = _useClassNames.merge;

  var classes = merge(className, withClassPrefix(appearance, color, size, {
    active: active,
    disabled: disabled,
    loading: loading,
    block: block
  }));

  var spin = /*#__PURE__*/_react.default.createElement("span", {
    className: prefix(_templateObject || (_templateObject = (0, _taggedTemplateLiteralLoose2.default)(["spiner"])))
  });

  if (href) {
    return /*#__PURE__*/_react.default.createElement(_Anchor.default, (0, _extends2.default)({
      href: href
    }, rest), children);
  }

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    className: classes,
    type: type
  }, rest), loading && spin, children);
};

Button.defaultProps = {
  active: false,
  size: "md",
  loading: false,
  classPrefix: "btn",
  appearance: "default",
  componentClass: "button",
  disabled: false,
  type: "button"
};
var _default = Button;
exports.default = _default;