"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _ = require("..");

var _utils = require("../utils");

var _createChainedFunction = _interopRequireDefault(require("../utils/createChainedFunction"));

var DropdownItem = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? _.Anchor : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "dropdown-item" : _props$classPrefix,
      children = props.children,
      className = props.className,
      active = props.active,
      onClick = props.onClick,
      onSelect = props.onSelect,
      itemKey = props.itemKey,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "classPrefix", "children", "className", "active", "onClick", "onSelect", "itemKey"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix({
    active: active
  }));
  var handleClick = (0, _react.useCallback)(function (event) {
    onSelect === null || onSelect === void 0 ? void 0 : onSelect(itemKey, event);
  }, [itemKey]);
  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    ref: ref,
    onClick: (0, _createChainedFunction.default)(handleClick, onClick),
    className: classes
  }, rest), children);
});

DropdownItem.defaultProps = {
  active: false
};
var _default = DropdownItem;
exports.default = _default;