"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _kebabCase2 = _interopRequireDefault(require("lodash/kebabCase"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var _createChainedFunction = _interopRequireDefault(require("../utils/createChainedFunction"));

var DropdownMenu = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "dropdown-menu" : _props$classPrefix,
      className = props.className,
      children = props.children,
      reset = props.reset,
      placement = props.placement,
      open = props.open,
      onSelect = props.onSelect,
      activeKey = props.activeKey,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "classPrefix", "className", "children", "reset", "placement", "open", "onSelect", "activeKey"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix((0, _kebabCase2.default)(placement), {
    rest: reset,
    open: open
  }));

  var getChildElement = function getChildElement() {
    var elements = _react.default.Children.map(children, function (child, index) {
      if (!child) {
        return null;
      } // render the child when the child as the dropdown item.


      var onItemSelected = props.onSelect;
      return /*#__PURE__*/_react.default.cloneElement(child, {
        key: index,
        onSelect: (0, _createChainedFunction.default)(onSelect, onItemSelected)
      });
    });

    return {
      elements: elements
    };
  };

  var _getChildElement = getChildElement(),
      elements = _getChildElement.elements;

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    ref: ref,
    className: classes
  }, rest), elements);
});

DropdownMenu.defaultProps = {
  reset: false
};
var _default = DropdownMenu;
exports.default = _default;