"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _utils = require("../utils");

var _MainHeader = _interopRequireDefault(require("./MainHeader"));

var _HeaderIcon = _interopRequireDefault(require("./HeaderIcon"));

var _HeaderExtra = _interopRequireDefault(require("./HeaderExtra"));

var _Page = require("../Page");

var _SidebarExpanderIcon = _interopRequireDefault(require("./SidebarExpanderIcon"));

var Header = function Header(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "page-header" : _props$classPrefix,
      className = props.className,
      title = props.title,
      renderTitle = props.renderTitle,
      navigation = props.navigation,
      headerIcon = props.headerIcon,
      extraElement = props.extraElement;

  var _useContext = (0, _react.useContext)(_Page.PageContext),
      setMinimizedSidebar = _useContext.setMinimizedSidebar;

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix,
      prefix = _useClassNames.prefix;

  var classes = merge(className, withClassPrefix({}));

  var handleCollapseSidebar = function handleCollapseSidebar() {
    setMinimizedSidebar === null || setMinimizedSidebar === void 0 ? void 0 : setMinimizedSidebar(false);
  };

  var mainHeaderProps = {
    title: title,
    navigation: navigation,
    renderTitle: renderTitle
  };
  var headerIconElement;

  if (headerIcon) {
    headerIconElement = /*#__PURE__*/_react.default.createElement(_HeaderIcon.default, null, headerIcon);
  }

  var headerExtraElement;

  if (extraElement) {
    headerExtraElement = /*#__PURE__*/_react.default.createElement(_HeaderExtra.default, null, extraElement);
  }

  return /*#__PURE__*/_react.default.createElement(Component, {
    className: classes
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: prefix("sidebar-expander"),
    onClick: function onClick() {
      return handleCollapseSidebar();
    }
  }, /*#__PURE__*/_react.default.createElement(_SidebarExpanderIcon.default, {
    height: "20",
    width: "20"
  })), headerIconElement, /*#__PURE__*/_react.default.createElement(_MainHeader.default, mainHeaderProps), headerExtraElement);
};

Header.defaultProps = {
  componentClass: "div",
  classPrefix: "page-header"
};
var _default = Header;
exports.default = _default;