"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

/**
 * Main Header Title Component
 * This create component for title of the header
 */
var MainHeaderTitle = (0, _utils.createComponent)({
  name: "MainHeaderTitle",
  as: "h1"
});
/**
 * Main Header Navigation Row Component.
 * This component use for warpping the navigation on the header
 */

var HeaderNavigationRow = (0, _utils.createComponent)({
  name: "HeaderNavigationRow",
  as: "div"
});

var MainHeader = function MainHeader(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      title = props.title,
      children = props.children,
      renderTitle = props.renderTitle,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "main-header" : _props$classPrefix,
      className = props.className,
      navigation = props.navigation,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "title", "children", "renderTitle", "classPrefix", "className", "navigation"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix({
    navigation: navigation
  }));
  var navigationComponent;

  if (navigation) {
    navigationComponent = /*#__PURE__*/_react.default.createElement(HeaderNavigationRow, null, navigation);
  }

  if (renderTitle) {
    return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
      className: classes
    }, rest), renderTitle(children), navigationComponent);
  }

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    className: classes
  }, rest), /*#__PURE__*/_react.default.createElement(MainHeaderTitle, null, title), navigationComponent);
};

var _default = MainHeader;
exports.default = _default;