"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var Input = function Input(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "input" : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "input" : _props$classPrefix,
      className = props.className,
      _props$hasError = props.hasError,
      hasError = _props$hasError === void 0 ? false : _props$hasError,
      size = props.size,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "classPrefix", "className", "hasError", "size"]);

  var ref = _react.default.useRef();

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix(size, {
    "has-error": hasError
  }));
  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    ref: ref,
    className: classes
  }, rest));
};

var _default = Input;
exports.default = _default;