"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var Nav = function Nav(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "nav" : _props$classPrefix,
      children = props.children,
      className = props.className,
      _props$appearance = props.appearance,
      appearance = _props$appearance === void 0 ? "default" : _props$appearance,
      _props$justified = props.justified,
      justified = _props$justified === void 0 ? false : _props$justified,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? "horizontal" : _props$direction,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "classPrefix", "children", "className", "appearance", "justified", "direction"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix(appearance, direction, {
    justified: justified
  }));
  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    className: classes
  }, rest), children);
};

Nav.defaultProps = {
  componentClass: "div",
  classPrefix: "nav",
  appearance: "default",
  direction: "horizontal"
};
var _default = Nav;
exports.default = _default;