"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _ = require("..");

var _utils = require("../utils");

// Create commponent for wrapping the nav options
var NavigationItemWrapper = (0, _utils.createComponent)({
  name: "NavItem",
  as: "div"
}); // Create component for icon before

var IconBefore = (0, _utils.createComponent)({
  name: "NavIconBefore",
  as: "div"
}); // Create component for icon after

var IconAfter = (0, _utils.createComponent)({
  name: "NavIconAfter",
  as: "div"
});

var NavItem = function NavItem(props) {
  var _props$classComponent = props.classComponent,
      Component = _props$classComponent === void 0 ? _.Anchor : _props$classComponent,
      children = props.children,
      className = props.className,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "nav-item-option" : _props$classPrefix,
      iconBefore = props.iconBefore,
      iconAfter = props.iconAfter,
      active = props.active,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["classComponent", "children", "className", "classPrefix", "iconBefore", "iconAfter", "active"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix({
    active: active
  }));

  var setIconBefore = iconBefore && /*#__PURE__*/_react.default.createElement(IconBefore, null, iconBefore);

  var setIconAfter = iconAfter && /*#__PURE__*/_react.default.createElement(IconAfter, null, iconBefore);

  return /*#__PURE__*/_react.default.createElement(NavigationItemWrapper, null, /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    className: classes
  }, rest), setIconBefore, children, setIconAfter));
};

NavItem.displayName = "NavItemOption";
var _default = NavItem;
exports.default = _default;