"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = exports.PageContext = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _utils = require("../utils");

var _PageMain = _interopRequireDefault(require("./PageMain"));

var _PageMainLayer = _interopRequireDefault(require("./PageMainLayer"));

var PageContext = /*#__PURE__*/_react.default.createContext({});

exports.PageContext = PageContext;

var Page = function Page(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      children = props.children,
      className = props.className,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "page" : _props$classPrefix,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "children", "className", "classPrefix"]);

  var _useState = (0, _react.useState)(false),
      hasSidebar = _useState[0],
      setHasSidebar = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      minimizedSidebar = _useState2[0],
      setMinimizedSidebar = _useState2[1];

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      withClassPrefix = _useClassNames.withClassPrefix,
      merge = _useClassNames.merge;

  var classnames = merge(className, withClassPrefix({
    "has-sidebar": hasSidebar,
    "sidebar-minimized": minimizedSidebar
  }));
  return /*#__PURE__*/_react.default.createElement(PageContext.Provider, {
    value: {
      setHasSidebar: setHasSidebar,
      setMinimizedSidebar: setMinimizedSidebar
    }
  }, /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    className: classnames
  }, rest), /*#__PURE__*/_react.default.createElement(_PageMain.default, null, /*#__PURE__*/_react.default.createElement(_PageMainLayer.default, null, children))));
};

var _default = Page;
exports.default = _default;