"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _Page = require("../Page");

var _utils = require("../utils");

var Sidebar = function Sidebar(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "aside" : _props$componentClass,
      children = props.children,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "sidebar" : _props$classPrefix,
      _props$width = props.width,
      width = _props$width === void 0 ? 240 : _props$width,
      className = props.className,
      collapsible = props.collapsible,
      expander = props.expander,
      style = props.style,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "children", "classPrefix", "width", "className", "collapsible", "expander", "style"]);

  var _useContext = (0, _react.useContext)(_Page.PageContext),
      setHasSidebar = _useContext.setHasSidebar,
      setMinimizedSidebar = _useContext.setMinimizedSidebar;

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      withClassPrefix = _useClassNames.withClassPrefix,
      merge = _useClassNames.merge;

  var classes = merge(className, withClassPrefix({
    collapse: collapsible
  })); // hook to the Page component that the child has a sidebar.

  (0, _react.useEffect)(function () {
    setHasSidebar === null || setHasSidebar === void 0 ? void 0 : setHasSidebar(true);
  }, [setHasSidebar]);

  var _handleCollapse = function handleCollapse() {
    setMinimizedSidebar === null || setMinimizedSidebar === void 0 ? void 0 : setMinimizedSidebar(true); // setIsCollapsible(!isCollapsible);
  };

  var styles = (0, _extends2.default)({
    width: width + "px"
  }, style);

  var getElements = function getElements() {
    var elements = _react.default.Children.map(children, function (child, index) {
      var _child$type;

      var displayName = child === null || child === void 0 ? void 0 : (_child$type = child.type) === null || _child$type === void 0 ? void 0 : _child$type.displayName;

      if (displayName === "SidebarHeader") {
        return /*#__PURE__*/_react.default.cloneElement(child, (0, _extends2.default)({
          key: index,
          expander: expander,
          handleCollapse: function handleCollapse() {
            return _handleCollapse;
          }
        }, child === null || child === void 0 ? void 0 : child.props));
      }

      return /*#__PURE__*/_react.default.cloneElement(child, (0, _extends2.default)({
        key: index
      }, child === null || child === void 0 ? void 0 : child.props));
    });

    return {
      elements: elements
    };
  };

  var _getElements = getElements(),
      elements = _getElements.elements;

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    style: styles,
    className: classes
  }, rest), elements);
};

Sidebar.defaultProps = {
  width: 240,
  classPrefix: "sidebar",
  componentClass: "aside"
};
var _default = Sidebar;
exports.default = _default;