"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var _SidebarExpanderIcon = _interopRequireDefault(require("./SidebarExpanderIcon"));

var SidebarHeader = function SidebarHeader(props) {
  var children = props.children,
      _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "sidebar-header" : _props$classPrefix,
      className = props.className,
      expander = props.expander,
      handleCollapse = props.handleCollapse,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["children", "componentClass", "classPrefix", "className", "expander", "handleCollapse"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix,
      prefix = _useClassNames.prefix;

  var classes = merge(className, withClassPrefix());
  var expanderElement;

  if (expander) {
    expanderElement = /*#__PURE__*/_react.default.createElement("div", {
      className: prefix("expander"),
      onClick: handleCollapse()
    }, /*#__PURE__*/_react.default.createElement(_SidebarExpanderIcon.default, null));
  }

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    className: classes
  }, rest), /*#__PURE__*/_react.default.createElement("div", {
    className: prefix("logo")
  }, children), expanderElement);
};

SidebarHeader.displayName = "SidebarHeader";
SidebarHeader.defaultProps = {
  componentClass: "div",
  classPrefix: "sidebar-header"
};
var _default = SidebarHeader;
exports.default = _default;