"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = exports.addPrefix = exports.setDefaultClassPrefix = exports.getClassNamePrefix = exports.defaultClassPrefix = void 0;

var _curry2 = _interopRequireDefault(require("lodash/curry"));

var _isArray2 = _interopRequireDefault(require("lodash/isArray"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultClassPrefix = 'ts-';
exports.defaultClassPrefix = defaultClassPrefix;

var getClassNamePrefix = function getClassNamePrefix() {
  return defaultClassPrefix;
};

exports.getClassNamePrefix = getClassNamePrefix;

var setDefaultClassPrefix = function setDefaultClassPrefix(name) {
  return "" + getClassNamePrefix() + name;
};

exports.setDefaultClassPrefix = setDefaultClassPrefix;

var addPrefix = function addPrefix(prefix, className) {
  if (!prefix || !className) {
    return '';
  }

  if ((0, _isArray2.default)(className)) {
    return (0, _classnames.default)(className.filter(function (name) {
      return !!name;
    }).map(function (name) {
      return prefix + "-" + name;
    }));
  }

  return prefix + "-" + className;
};

exports.addPrefix = addPrefix;

var _default = (0, _curry2.default)(addPrefix);

exports.default = _default;