"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _kebabCase2 = _interopRequireDefault(require("lodash/kebabCase"));

var React = _interopRequireWildcard(require("react"));

var _ = require(".");

var createComponent = function createComponent(defaultProps) {
  var as = defaultProps.as,
      name = defaultProps.name,
      classPrefix = defaultProps.classPrefix,
      componentRestProps = (0, _objectWithoutPropertiesLoose2.default)(defaultProps, ["as", "name", "classPrefix"]);
  var Component = /*#__PURE__*/React.forwardRef(function (props, ref) {
    var Component = props.as,
        children = props.children,
        className = props.className,
        classPrefix = props.classPrefix,
        rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["as", "children", "className", "classPrefix"]);

    var _useClassNames = (0, _.useClassNames)(classPrefix),
        merge = _useClassNames.merge,
        withClassPrefix = _useClassNames.withClassPrefix;

    var classes = merge(className, withClassPrefix());
    return /*#__PURE__*/React.createElement(Component, (0, _extends2.default)({
      ref: ref,
      className: classes
    }, rest), children);
  });
  Component.displayName = name;
  Component.defaultProps = (0, _extends2.default)({}, componentRestProps, {
    as: as || "div",
    classPrefix: classPrefix || (0, _kebabCase2.default)(name)
  });
  return Component;
};

var _default = createComponent;
exports.default = _default;